# Shares

A share represents a directory on a Network File Storage cluster, where options like quotas can be set for the directory.

This tag groups all operations for shares.

## Retrieve all Shares

> This endpoint enables retrieving all Shares using\
> pagination and optional filters.<br>

```json
{"openapi":"3.0.3","info":{"title":"IONOS Cloud - Network File Storage API","version":"0.1.6"},"tags":[{"name":"Shares","description":"A share represents a directory on a Network File Storage cluster, where options like quotas can be set for the directory.\n\nThis tag groups all operations for shares.\n"}],"servers":[{"url":"https://nfs.de-fra.ionos.com","description":"service endpoint for location de-fra"},{"url":"https://nfs.de-txl.ionos.com","description":"service endpoint for location de-txl"},{"url":"https://nfs.es-vit.ionos.com","description":"service endpoint for location es-vit"},{"url":"https://nfs.fr-par.ionos.com","description":"service endpoint for location fr-par"},{"url":"https://nfs.gb-lhr.ionos.com","description":"service endpoint for location gb-lhr"},{"url":"https://nfs.us-ewr.ionos.com","description":"service endpoint for location us-ewr"},{"url":"https://nfs.us-las.ionos.com","description":"service endpoint for location us-las"},{"url":"https://nfs.us-mci.ionos.com","description":"service endpoint for location us-mci"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"parameters":{"paginationOffset":{"name":"offset","in":"query","description":"The first element (of the total list of elements) to include in the response. Use this parameter together with the limit for pagination.","required":false,"schema":{"type":"integer","format":"int32","default":0,"minimum":0}},"paginationLimit":{"name":"limit","in":"query","description":"The maximum number of elements to return. Use this parameter together with the offset for pagination.","required":false,"schema":{"type":"integer","format":"int32","default":100,"minimum":1,"maximum":1000}}},"schemas":{"ShareReadList":{"allOf":[{"type":"object","required":["id","type","href"],"properties":{"id":{"description":"ID of the list of Share resources.","type":"string","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["collection"]},"href":{"description":"The URL of the list of Share resources.","type":"string"},"items":{"description":"The list of Share resources.","type":"array","items":{"$ref":"#/components/schemas/ShareRead"}}}},{"$ref":"#/components/schemas/Pagination"}]},"ShareRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Share.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["share"]},"href":{"description":"The URL of the Share.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithPath"},"properties":{"$ref":"#/components/schemas/Share"}}},"MetadataWithPath":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","required":["nfsPath"],"properties":{"nfsPath":{"type":"string","description":"The path of the NFS export (currently equal to the UUID of the share).\nOn a machine with access to the share, mount it using the following command: `mount -t nfs <cluster-ip>:<nfs-path> <target-dir>`\n","readOnly":true}}}]},"MetadataWithStatus":{"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["status"],"properties":{"status":{"type":"string","description":"The status of the resource can be one of the following:\n* `AVAILABLE` - The resource exists and is healthy.\n* `PROVISIONING` - The resource is being created or updated.\n* `DESTROYING` - A delete command was issued, and the resource is being deleted.\n* `FAILED` - The resource failed, with details provided in `statusMessage`.\n","enum":["PROVISIONING","DESTROYING","AVAILABLE","FAILED"],"readOnly":true},"statusMessage":{"type":"string","description":"The error message when the status is `FAILED`.\n","readOnly":true}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Share":{"type":"object","description":"A share represents a directory on a Network File Storage cluster, where options like quotas can be set for the directory.\n","required":["name","clientGroups"],"properties":{"name":{"type":"string","description":"Name of the share"},"quota":{"type":"integer","description":"The quota for the export in MiB, which can limit the amount of data stored. Setting the quota to 0 will disable it.\n","default":0,"minimum":0},"gid":{"type":"integer","description":"The group ID that will own the exported directory and be used as the `anongid` NFS option in squash modes `root-anonymous` and `all-anonymous`.\n","default":65534,"maximum":65534},"uid":{"type":"integer","description":"The user ID that will own the exported directory and be used as the `anonuid` NFS option in squash modes `root-anonymous` and `all-anonymous`.\n","default":65534,"maximum":65534},"clientGroups":{"type":"array","minItems":1,"description":"Client groups are the virtual machines connecting to the Network File Storage cluster.\n","items":{"type":"object","properties":{"description":{"type":"string","description":"Optional description for the client group.\n"},"ipNetworks":{"type":"array","items":{"type":"string","description":"The allowed host or network to which the export is being shared.\nThe IP address can be either IPv4 or IPv6 and has to be given with CIDR notation.\nThis setting will always supersede the list of hosts.\nOnly use this field if you want the share access on the entire network. In case you need to grant access to specific hosts, leave this field blank.\n"}},"hosts":{"type":"array","items":{"type":"string","description":"A single host allowed to connect to the share. The host can be specified using an IP address,\nwhich can be either IPv4 or IPv6.\n"}},"nfs":{"type":"object","description":"NFS specific configurations.\n","properties":{"squash":{"type":"string","description":"The NFS squash mode for the export can be set to:\n* `none` - No squash mode, no mapping. The share directory will be owned by the given UID/GID. (`no_all_squash,no_root_squash`)\n* `root-anonymous` - Map root user to the anonymous UID/GID. The share directory will be owned by the given UID/GID. (`root_squash,anonuid=<uid>,anongid=<gid>`)\n* `all-anonymous` - Map all users an internal anonymous UID/GID. The given UID/GID will be ignored. (`all_squash,anonuid=<uid>,anongid=<gid>`)\n","enum":["none","root-anonymous","all-anonymous"],"default":"none"}}}}}}}},"Pagination":{"required":["offset","limit","_links"],"description":"Pagination information. The offset and limit parameters are used to\nnavigate the list of elements. The _links object contains URLs to\nnavigate the different pages.\n","type":"object","properties":{"offset":{"$ref":"#/components/schemas/Offset"},"limit":{"$ref":"#/components/schemas/Limit"},"_links":{"$ref":"#/components/schemas/Links"}}},"Offset":{"description":"The offset specified in the request (if none was specified, the default\noffset is 0).\n","type":"integer","minimum":0,"readOnly":true},"Limit":{"description":"The limit specified in the request (if none was specified, use the\nendpoint's default pagination limit).\n","type":"integer","minimum":0,"readOnly":true},"Links":{"description":"URLs to navigate the different pages. As of now we always only return a\nsingle page.\n","type":"object","properties":{"prev":{"description":"URL (with offset and limit parameters) of the previous page; only\npresent if offset is greater than 0.\n","type":"string","format":"uri","readOnly":true},"self":{"description":"URL (with offset and limit parameters) of the current page.\n","type":"string","format":"uri","readOnly":true},"next":{"description":"URL (with offset and limit parameters) of the next page; only\npresent if offset + limit is less than the total number of elements.\n","type":"string","format":"uri","readOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/clusters/{clusterId}/shares":{"get":{"operationId":"clustersSharesGet","summary":"Retrieve all Shares","description":"This endpoint enables retrieving all Shares using\npagination and optional filters.\n","parameters":[{"name":"clusterId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Cluster."},{"$ref":"#/components/parameters/paginationOffset"},{"$ref":"#/components/parameters/paginationLimit"}],"tags":["Shares"],"responses":{"200":{"description":"Returned all requested Shares successfully.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ShareReadList"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Create Share

> Creates a new Share.\
> \
> The full Share needs to be provided to create the object.\
> Optional data will be filled with defaults or left empty.<br>

```json
{"openapi":"3.0.3","info":{"title":"IONOS Cloud - Network File Storage API","version":"0.1.6"},"tags":[{"name":"Shares","description":"A share represents a directory on a Network File Storage cluster, where options like quotas can be set for the directory.\n\nThis tag groups all operations for shares.\n"}],"servers":[{"url":"https://nfs.de-fra.ionos.com","description":"service endpoint for location de-fra"},{"url":"https://nfs.de-txl.ionos.com","description":"service endpoint for location de-txl"},{"url":"https://nfs.es-vit.ionos.com","description":"service endpoint for location es-vit"},{"url":"https://nfs.fr-par.ionos.com","description":"service endpoint for location fr-par"},{"url":"https://nfs.gb-lhr.ionos.com","description":"service endpoint for location gb-lhr"},{"url":"https://nfs.us-ewr.ionos.com","description":"service endpoint for location us-ewr"},{"url":"https://nfs.us-las.ionos.com","description":"service endpoint for location us-las"},{"url":"https://nfs.us-mci.ionos.com","description":"service endpoint for location us-mci"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"ShareCreate":{"type":"object","required":["properties"],"properties":{"metadata":{"description":"Metadata","additionalProperties":true},"properties":{"$ref":"#/components/schemas/Share"}}},"Share":{"type":"object","description":"A share represents a directory on a Network File Storage cluster, where options like quotas can be set for the directory.\n","required":["name","clientGroups"],"properties":{"name":{"type":"string","description":"Name of the share"},"quota":{"type":"integer","description":"The quota for the export in MiB, which can limit the amount of data stored. Setting the quota to 0 will disable it.\n","default":0,"minimum":0},"gid":{"type":"integer","description":"The group ID that will own the exported directory and be used as the `anongid` NFS option in squash modes `root-anonymous` and `all-anonymous`.\n","default":65534,"maximum":65534},"uid":{"type":"integer","description":"The user ID that will own the exported directory and be used as the `anonuid` NFS option in squash modes `root-anonymous` and `all-anonymous`.\n","default":65534,"maximum":65534},"clientGroups":{"type":"array","minItems":1,"description":"Client groups are the virtual machines connecting to the Network File Storage cluster.\n","items":{"type":"object","properties":{"description":{"type":"string","description":"Optional description for the client group.\n"},"ipNetworks":{"type":"array","items":{"type":"string","description":"The allowed host or network to which the export is being shared.\nThe IP address can be either IPv4 or IPv6 and has to be given with CIDR notation.\nThis setting will always supersede the list of hosts.\nOnly use this field if you want the share access on the entire network. In case you need to grant access to specific hosts, leave this field blank.\n"}},"hosts":{"type":"array","items":{"type":"string","description":"A single host allowed to connect to the share. The host can be specified using an IP address,\nwhich can be either IPv4 or IPv6.\n"}},"nfs":{"type":"object","description":"NFS specific configurations.\n","properties":{"squash":{"type":"string","description":"The NFS squash mode for the export can be set to:\n* `none` - No squash mode, no mapping. The share directory will be owned by the given UID/GID. (`no_all_squash,no_root_squash`)\n* `root-anonymous` - Map root user to the anonymous UID/GID. The share directory will be owned by the given UID/GID. (`root_squash,anonuid=<uid>,anongid=<gid>`)\n* `all-anonymous` - Map all users an internal anonymous UID/GID. The given UID/GID will be ignored. (`all_squash,anonuid=<uid>,anongid=<gid>`)\n","enum":["none","root-anonymous","all-anonymous"],"default":"none"}}}}}}}},"ShareRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Share.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["share"]},"href":{"description":"The URL of the Share.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithPath"},"properties":{"$ref":"#/components/schemas/Share"}}},"MetadataWithPath":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","required":["nfsPath"],"properties":{"nfsPath":{"type":"string","description":"The path of the NFS export (currently equal to the UUID of the share).\nOn a machine with access to the share, mount it using the following command: `mount -t nfs <cluster-ip>:<nfs-path> <target-dir>`\n","readOnly":true}}}]},"MetadataWithStatus":{"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["status"],"properties":{"status":{"type":"string","description":"The status of the resource can be one of the following:\n* `AVAILABLE` - The resource exists and is healthy.\n* `PROVISIONING` - The resource is being created or updated.\n* `DESTROYING` - A delete command was issued, and the resource is being deleted.\n* `FAILED` - The resource failed, with details provided in `statusMessage`.\n","enum":["PROVISIONING","DESTROYING","AVAILABLE","FAILED"],"readOnly":true},"statusMessage":{"type":"string","description":"The error message when the status is `FAILED`.\n","readOnly":true}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnsupportedMediaType":{"description":"### Unsupported Media Type\nThe request has an unsupported media type.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnprocessableEntity":{"description":"### Unprocessable Entity\nThe request was well-formed but was unable to be followed due to semantic errors.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/clusters/{clusterId}/shares":{"post":{"operationId":"clustersSharesPost","summary":"Create Share","tags":["Shares"],"description":"Creates a new Share.\n\nThe full Share needs to be provided to create the object.\nOptional data will be filled with defaults or left empty.\n","parameters":[{"name":"clusterId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Cluster."}],"requestBody":{"description":"Share to create.","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ShareCreate"}}}},"responses":{"201":{"description":"Share successfully created.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ShareRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"415":{"$ref":"#/components/responses/UnsupportedMediaType"},"422":{"$ref":"#/components/responses/UnprocessableEntity"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Retrieve Share

> Returns the Share by ID.

```json
{"openapi":"3.0.3","info":{"title":"IONOS Cloud - Network File Storage API","version":"0.1.6"},"tags":[{"name":"Shares","description":"A share represents a directory on a Network File Storage cluster, where options like quotas can be set for the directory.\n\nThis tag groups all operations for shares.\n"}],"servers":[{"url":"https://nfs.de-fra.ionos.com","description":"service endpoint for location de-fra"},{"url":"https://nfs.de-txl.ionos.com","description":"service endpoint for location de-txl"},{"url":"https://nfs.es-vit.ionos.com","description":"service endpoint for location es-vit"},{"url":"https://nfs.fr-par.ionos.com","description":"service endpoint for location fr-par"},{"url":"https://nfs.gb-lhr.ionos.com","description":"service endpoint for location gb-lhr"},{"url":"https://nfs.us-ewr.ionos.com","description":"service endpoint for location us-ewr"},{"url":"https://nfs.us-las.ionos.com","description":"service endpoint for location us-las"},{"url":"https://nfs.us-mci.ionos.com","description":"service endpoint for location us-mci"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"ShareRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Share.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["share"]},"href":{"description":"The URL of the Share.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithPath"},"properties":{"$ref":"#/components/schemas/Share"}}},"MetadataWithPath":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","required":["nfsPath"],"properties":{"nfsPath":{"type":"string","description":"The path of the NFS export (currently equal to the UUID of the share).\nOn a machine with access to the share, mount it using the following command: `mount -t nfs <cluster-ip>:<nfs-path> <target-dir>`\n","readOnly":true}}}]},"MetadataWithStatus":{"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["status"],"properties":{"status":{"type":"string","description":"The status of the resource can be one of the following:\n* `AVAILABLE` - The resource exists and is healthy.\n* `PROVISIONING` - The resource is being created or updated.\n* `DESTROYING` - A delete command was issued, and the resource is being deleted.\n* `FAILED` - The resource failed, with details provided in `statusMessage`.\n","enum":["PROVISIONING","DESTROYING","AVAILABLE","FAILED"],"readOnly":true},"statusMessage":{"type":"string","description":"The error message when the status is `FAILED`.\n","readOnly":true}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Share":{"type":"object","description":"A share represents a directory on a Network File Storage cluster, where options like quotas can be set for the directory.\n","required":["name","clientGroups"],"properties":{"name":{"type":"string","description":"Name of the share"},"quota":{"type":"integer","description":"The quota for the export in MiB, which can limit the amount of data stored. Setting the quota to 0 will disable it.\n","default":0,"minimum":0},"gid":{"type":"integer","description":"The group ID that will own the exported directory and be used as the `anongid` NFS option in squash modes `root-anonymous` and `all-anonymous`.\n","default":65534,"maximum":65534},"uid":{"type":"integer","description":"The user ID that will own the exported directory and be used as the `anonuid` NFS option in squash modes `root-anonymous` and `all-anonymous`.\n","default":65534,"maximum":65534},"clientGroups":{"type":"array","minItems":1,"description":"Client groups are the virtual machines connecting to the Network File Storage cluster.\n","items":{"type":"object","properties":{"description":{"type":"string","description":"Optional description for the client group.\n"},"ipNetworks":{"type":"array","items":{"type":"string","description":"The allowed host or network to which the export is being shared.\nThe IP address can be either IPv4 or IPv6 and has to be given with CIDR notation.\nThis setting will always supersede the list of hosts.\nOnly use this field if you want the share access on the entire network. In case you need to grant access to specific hosts, leave this field blank.\n"}},"hosts":{"type":"array","items":{"type":"string","description":"A single host allowed to connect to the share. The host can be specified using an IP address,\nwhich can be either IPv4 or IPv6.\n"}},"nfs":{"type":"object","description":"NFS specific configurations.\n","properties":{"squash":{"type":"string","description":"The NFS squash mode for the export can be set to:\n* `none` - No squash mode, no mapping. The share directory will be owned by the given UID/GID. (`no_all_squash,no_root_squash`)\n* `root-anonymous` - Map root user to the anonymous UID/GID. The share directory will be owned by the given UID/GID. (`root_squash,anonuid=<uid>,anongid=<gid>`)\n* `all-anonymous` - Map all users an internal anonymous UID/GID. The given UID/GID will be ignored. (`all_squash,anonuid=<uid>,anongid=<gid>`)\n","enum":["none","root-anonymous","all-anonymous"],"default":"none"}}}}}}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/clusters/{clusterId}/shares/{shareId}":{"get":{"operationId":"clustersSharesFindById","summary":"Retrieve Share","tags":["Shares"],"description":"Returns the Share by ID.","parameters":[{"name":"clusterId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Cluster."},{"name":"shareId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Share."}],"responses":{"200":{"description":"Getting Share was successful.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ShareRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Ensure Share

> Ensures that the Share with the provided ID is created or modified.\
> The full Share needs to be provided to ensure\
> (either update or create) the Share. Non present data will\
> only be filled with defaults or left empty, but not take\
> previous values into consideration.<br>

```json
{"openapi":"3.0.3","info":{"title":"IONOS Cloud - Network File Storage API","version":"0.1.6"},"tags":[{"name":"Shares","description":"A share represents a directory on a Network File Storage cluster, where options like quotas can be set for the directory.\n\nThis tag groups all operations for shares.\n"}],"servers":[{"url":"https://nfs.de-fra.ionos.com","description":"service endpoint for location de-fra"},{"url":"https://nfs.de-txl.ionos.com","description":"service endpoint for location de-txl"},{"url":"https://nfs.es-vit.ionos.com","description":"service endpoint for location es-vit"},{"url":"https://nfs.fr-par.ionos.com","description":"service endpoint for location fr-par"},{"url":"https://nfs.gb-lhr.ionos.com","description":"service endpoint for location gb-lhr"},{"url":"https://nfs.us-ewr.ionos.com","description":"service endpoint for location us-ewr"},{"url":"https://nfs.us-las.ionos.com","description":"service endpoint for location us-las"},{"url":"https://nfs.us-mci.ionos.com","description":"service endpoint for location us-mci"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"ShareEnsure":{"type":"object","required":["id","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Share.","format":"uuid"},"metadata":{"description":"Metadata","additionalProperties":true},"properties":{"$ref":"#/components/schemas/Share"}}},"Share":{"type":"object","description":"A share represents a directory on a Network File Storage cluster, where options like quotas can be set for the directory.\n","required":["name","clientGroups"],"properties":{"name":{"type":"string","description":"Name of the share"},"quota":{"type":"integer","description":"The quota for the export in MiB, which can limit the amount of data stored. Setting the quota to 0 will disable it.\n","default":0,"minimum":0},"gid":{"type":"integer","description":"The group ID that will own the exported directory and be used as the `anongid` NFS option in squash modes `root-anonymous` and `all-anonymous`.\n","default":65534,"maximum":65534},"uid":{"type":"integer","description":"The user ID that will own the exported directory and be used as the `anonuid` NFS option in squash modes `root-anonymous` and `all-anonymous`.\n","default":65534,"maximum":65534},"clientGroups":{"type":"array","minItems":1,"description":"Client groups are the virtual machines connecting to the Network File Storage cluster.\n","items":{"type":"object","properties":{"description":{"type":"string","description":"Optional description for the client group.\n"},"ipNetworks":{"type":"array","items":{"type":"string","description":"The allowed host or network to which the export is being shared.\nThe IP address can be either IPv4 or IPv6 and has to be given with CIDR notation.\nThis setting will always supersede the list of hosts.\nOnly use this field if you want the share access on the entire network. In case you need to grant access to specific hosts, leave this field blank.\n"}},"hosts":{"type":"array","items":{"type":"string","description":"A single host allowed to connect to the share. The host can be specified using an IP address,\nwhich can be either IPv4 or IPv6.\n"}},"nfs":{"type":"object","description":"NFS specific configurations.\n","properties":{"squash":{"type":"string","description":"The NFS squash mode for the export can be set to:\n* `none` - No squash mode, no mapping. The share directory will be owned by the given UID/GID. (`no_all_squash,no_root_squash`)\n* `root-anonymous` - Map root user to the anonymous UID/GID. The share directory will be owned by the given UID/GID. (`root_squash,anonuid=<uid>,anongid=<gid>`)\n* `all-anonymous` - Map all users an internal anonymous UID/GID. The given UID/GID will be ignored. (`all_squash,anonuid=<uid>,anongid=<gid>`)\n","enum":["none","root-anonymous","all-anonymous"],"default":"none"}}}}}}}},"ShareRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Share.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["share"]},"href":{"description":"The URL of the Share.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithPath"},"properties":{"$ref":"#/components/schemas/Share"}}},"MetadataWithPath":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","required":["nfsPath"],"properties":{"nfsPath":{"type":"string","description":"The path of the NFS export (currently equal to the UUID of the share).\nOn a machine with access to the share, mount it using the following command: `mount -t nfs <cluster-ip>:<nfs-path> <target-dir>`\n","readOnly":true}}}]},"MetadataWithStatus":{"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["status"],"properties":{"status":{"type":"string","description":"The status of the resource can be one of the following:\n* `AVAILABLE` - The resource exists and is healthy.\n* `PROVISIONING` - The resource is being created or updated.\n* `DESTROYING` - A delete command was issued, and the resource is being deleted.\n* `FAILED` - The resource failed, with details provided in `statusMessage`.\n","enum":["PROVISIONING","DESTROYING","AVAILABLE","FAILED"],"readOnly":true},"statusMessage":{"type":"string","description":"The error message when the status is `FAILED`.\n","readOnly":true}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Conflict":{"description":"### Conflict\nThe UUID is already taken by another party, follow the guides to generate UUIDs uniquely.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnsupportedMediaType":{"description":"### Unsupported Media Type\nThe request has an unsupported media type.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnprocessableEntity":{"description":"### Unprocessable Entity\nThe request was well-formed but was unable to be followed due to semantic errors.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/clusters/{clusterId}/shares/{shareId}":{"put":{"operationId":"clustersSharesPut","summary":"Ensure Share","tags":["Shares"],"description":"Ensures that the Share with the provided ID is created or modified.\nThe full Share needs to be provided to ensure\n(either update or create) the Share. Non present data will\nonly be filled with defaults or left empty, but not take\nprevious values into consideration.\n","parameters":[{"name":"clusterId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Cluster."},{"name":"shareId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Share."}],"requestBody":{"description":"update Share","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ShareEnsure"}}}},"responses":{"200":{"description":"Share successfully updated.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ShareRead"}}}},"201":{"description":"Share successfully ensured.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ShareRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"409":{"$ref":"#/components/responses/Conflict"},"415":{"$ref":"#/components/responses/UnsupportedMediaType"},"422":{"$ref":"#/components/responses/UnprocessableEntity"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Delete Share

> Deletes the specified Share.

```json
{"openapi":"3.0.3","info":{"title":"IONOS Cloud - Network File Storage API","version":"0.1.6"},"tags":[{"name":"Shares","description":"A share represents a directory on a Network File Storage cluster, where options like quotas can be set for the directory.\n\nThis tag groups all operations for shares.\n"}],"servers":[{"url":"https://nfs.de-fra.ionos.com","description":"service endpoint for location de-fra"},{"url":"https://nfs.de-txl.ionos.com","description":"service endpoint for location de-txl"},{"url":"https://nfs.es-vit.ionos.com","description":"service endpoint for location es-vit"},{"url":"https://nfs.fr-par.ionos.com","description":"service endpoint for location fr-par"},{"url":"https://nfs.gb-lhr.ionos.com","description":"service endpoint for location gb-lhr"},{"url":"https://nfs.us-ewr.ionos.com","description":"service endpoint for location us-ewr"},{"url":"https://nfs.us-las.ionos.com","description":"service endpoint for location us-las"},{"url":"https://nfs.us-mci.ionos.com","description":"service endpoint for location us-mci"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}},"schemas":{"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}}},"paths":{"/clusters/{clusterId}/shares/{shareId}":{"delete":{"operationId":"clustersSharesDelete","summary":"Delete Share","tags":["Shares"],"description":"Deletes the specified Share.","parameters":[{"name":"clusterId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Cluster."},{"name":"shareId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Share."}],"responses":{"202":{"description":"Deleting Share was successful."},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```
